// filter_wrap.h
// FILTER\̃bp
// Copyright (c) 2008 N099
//
#pragma once
#include "filter.h"

#ifdef UNICODE
#error Cant't cmpile in UNICODE !!
#endif

struct ATFilter : public FILTER
{
	//display infomations
	void PrintFlag(std::ostream& os) const;
	void PrintWindowSize(std::ostream& os) const;
	void PrintTrack(std::ostream& os) const;
	void PrintCheck(std::ostream& os) const;
	void PintExData(std::ostream& os) const;
	void PrintMisc(std::ostream& os) const;
	void PrintFunc(std::ostream& os) const;
	void PrintWndMsg(std::ostream& os, UINT msg) const;
};

//filter functions
typedef BOOL (__cdecl * F_PROC)(void*, FILTER_PROC_INFO*);
typedef BOOL (__cdecl * F_INIT)(void*);
typedef BOOL (__cdecl * F_EXIT)(void*);
typedef BOOL (__cdecl * F_UPDATE)(void*, int);
typedef BOOL (__cdecl * F_WPROC)(HWND, UINT, WPARAM, LPARAM, void*, void*);
typedef BOOL (__cdecl * F_SAVE_START)(void*, int, int, void*);
typedef BOOL (__cdecl * F_SAVE_END)(void*, void*);
typedef BOOL (__cdecl * F_IS_SAVEFRM)(void*, void*, int, int, int, int, int);
typedef BOOL (__cdecl * F_PROJ_LOAD)(void*, void*, void*, int);
typedef BOOL (__cdecl * F_PROJ_SAVE)(void*, void*, void*, int*);
typedef BOOL (__cdecl * F_MOD_TITLE)(void*, void*, int, LPSTR, int);

struct ATFFuncTable{
	F_PROC proc;
	F_INIT init;
	F_EXIT exit;
	F_UPDATE update;
	F_WPROC WndProc;
	F_SAVE_START save_start;
	F_SAVE_END save_end;
	F_IS_SAVEFRM is_saveframe;
	F_PROJ_LOAD project_load;
	F_PROJ_SAVE project_save;
	F_MOD_TITLE modify_title;
};

class ATFWrap
{
private:
	ATFilter* _auf;
	int       _id;
	ATFilter  _oauf;

public:
	ATFWrap(ATFilter* af, int id) : _auf(af), _id(id), _oauf(*af) {}
	void WrapFunc(ATFFuncTable *tbl, EXFUNC *exf);
	void Restore();
	const ATFilter& GetOriginalFilter() const { return _oauf; }
	void DispFilterInfo(std::ostream& os) const;

	EXFUNC* ExFuncOrig() { return _oauf.exfunc; }
	BOOL FuncProcOrig(void *fp, FILTER_PROC_INFO *fpip);
	BOOL FuncInitOrig(void *fp);
	BOOL FuncExitOrig(void *fp);
	BOOL FuncUpdateOrig(void *fp, int n);
	BOOL FuncWndProcOrig(HWND h, UINT m, WPARAM w, LPARAM l, void *e, void *f);
	BOOL FuncSaveStartOrig(void *fp, int s, int e, void *editp);
	BOOL FuncSaveEndOrig(void *fp, void *editp);
	BOOL FuncIsSaveFrameOrig(void *fp, void *editp, int sno, int frame, int fps, int eflg, int ires);
	BOOL FuncProjectLoadOrig(void *fp, void *editp, void *dat, int size);
	BOOL FuncProjectSaveOrig(void *fp, void *editp, void *dat, int *size);
	BOOL FuncModifyTitleOrig(void *fp, void *editp, int frame, LPSTR title, int max);
	
	static bool LessPtr(const ATFWrap* a, const ATFWrap* b)
	{ return a->_id < b->_id; }

private:
	template< class T > void wrap_fptr( T &old_fptr, T new_fptr )
	{ if(old_fptr) old_fptr = new_fptr; }
};
